<?php
/**
 * PutCorporationsCorporationIdStructuresStructureIdNewSchedule
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * EVE Swagger Interface
 *
 * An OpenAPI for EVE Online
 *
 * OpenAPI spec version: 0.5.6
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;

/**
 * PutCorporationsCorporationIdStructuresStructureIdNewSchedule Class Doc Comment
 *
 * @category    Class */
 // @description new_schedule object
/** 
 * @package     Swagger\Client
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class PutCorporationsCorporationIdStructuresStructureIdNewSchedule implements ArrayAccess
{
    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'put_corporations_corporation_id_structures_structure_id_new_schedule';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = array(
        'day' => 'int',
        'hour' => 'int'
    );

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = array(
        'day' => 'day',
        'hour' => 'hour'
    );

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = array(
        'day' => 'setDay',
        'hour' => 'setHour'
    );

    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = array(
        'day' => 'getDay',
        'hour' => 'getHour'
    );

    public static function getters()
    {
        return self::$getters;
    }

    

    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = array();

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['day'] = isset($data['day']) ? $data['day'] : null;
        $this->container['hour'] = isset($data['hour']) ? $data['hour'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = array();
        if ($this->container['day'] === null) {
            $invalid_properties[] = "'day' can't be null";
        }
        if (($this->container['day'] > 6.0)) {
            $invalid_properties[] = "invalid value for 'day', must be smaller than or equal to 6.0.";
        }

        if (($this->container['day'] < 0.0)) {
            $invalid_properties[] = "invalid value for 'day', must be bigger than or equal to 0.0.";
        }

        if ($this->container['hour'] === null) {
            $invalid_properties[] = "'hour' can't be null";
        }
        if (($this->container['hour'] > 23.0)) {
            $invalid_properties[] = "invalid value for 'hour', must be smaller than or equal to 23.0.";
        }

        if (($this->container['hour'] < 0.0)) {
            $invalid_properties[] = "invalid value for 'hour', must be bigger than or equal to 0.0.";
        }

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properteis are valid
     */
    public function valid()
    {
        if ($this->container['day'] === null) {
            return false;
        }
        if ($this->container['day'] > 6.0) {
            return false;
        }
        if ($this->container['day'] < 0.0) {
            return false;
        }
        if ($this->container['hour'] === null) {
            return false;
        }
        if ($this->container['hour'] > 23.0) {
            return false;
        }
        if ($this->container['hour'] < 0.0) {
            return false;
        }
        return true;
    }


    /**
     * Gets day
     * @return int
     */
    public function getDay()
    {
        return $this->container['day'];
    }

    /**
     * Sets day
     * @param int $day Day of the week, zero-indexed to Monday
     * @return $this
     */
    public function setDay($day)
    {

        if ($day > 6.0) {
            throw new \InvalidArgumentException('invalid value for $day when calling PutCorporationsCorporationIdStructuresStructureIdNewSchedule., must be smaller than or equal to 6.0.');
        }
        if ($day < 0.0) {
            throw new \InvalidArgumentException('invalid value for $day when calling PutCorporationsCorporationIdStructuresStructureIdNewSchedule., must be bigger than or equal to 0.0.');
        }
        $this->container['day'] = $day;

        return $this;
    }

    /**
     * Gets hour
     * @return int
     */
    public function getHour()
    {
        return $this->container['hour'];
    }

    /**
     * Sets hour
     * @param int $hour Hour of the day evetime, zero-indexed to midnight
     * @return $this
     */
    public function setHour($hour)
    {

        if ($hour > 23.0) {
            throw new \InvalidArgumentException('invalid value for $hour when calling PutCorporationsCorporationIdStructuresStructureIdNewSchedule., must be smaller than or equal to 23.0.');
        }
        if ($hour < 0.0) {
            throw new \InvalidArgumentException('invalid value for $hour when calling PutCorporationsCorporationIdStructuresStructureIdNewSchedule., must be bigger than or equal to 0.0.');
        }
        $this->container['hour'] = $hour;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this));
    }
}


